#include "gpdef.h"
#include "gpstdlib.h"
#include "gpgraphic.h"
#include "gpfont.h"
#include "gpstdio.h"

#include "file_dialog.h"
#include "bfont.h"
#include "gpmain.h"
#include "textdraw.h"

extern GPDRAWSURFACE gpDraw[2];
extern int nflip;
char *tmp_string[MAX_PATH_NAME_LEN];
extern char g_string[MAX_PATH_NAME_LEN];
//-   ...  
#define n_fstr 17

extern ERR_CODE _make_final_path(const char * p_name);
extern char _relative_path[MAX_PATH_NAME_LEN];
extern char _final_path[MAX_PATH_NAME_LEN];

GPDIRENTRY *p_list;
typedef struct {           
	//char name[16];
	int type;
	unsigned int size;
}MYDIRENTRY;
MYDIRENTRY	*pi_list;

unsigned long list_count = 0, read_count = 0;

int GetFilesList(char *start_path)
{
	ERR_CODE err_code;
	GPFILEATTR mAttr;
	//char current_path[100];
	int i;
	unsigned long ts;

	list_count = 0;
	read_count = 0;

	//gp_str_func.strcpy((char*)&current_path, (const char*)start_path);

	DrawMessage(start_path, nflip);
	FlipAndShow();

	GpRelativePathSet(start_path);
	
	//__printf("set relativre path\n");

	err_code = GpDirEnumNum("\\", &list_count);
	if (err_code != SM_OK)
	{
		// 
		return -1;
	}
	// <=
	if (list_count==0)
	{
		// 
		return -2;
	}
	
	/*GpDirEnumList
		entry_start_idx : zero base 
		list_count : entry_start_idx
		read_count : 
		!!! : GPDIRENTRYL name full path
	  GpFileAttr	  	
	*/

	__printf("Getting files names\n");

	if (pi_list != NULL)
	{
		gp_mem_func.free(pi_list);
	}
	if (p_list != NULL)
	{
		gp_mem_func.free(p_list);
	}
	
	p_list = (GPDIRENTRY*)gp_mem_func.calloc((int)list_count, sizeof(GPDIRENTRY));
	pi_list = (MYDIRENTRY*)gp_mem_func.calloc((int)list_count, sizeof(MYDIRENTRY));
	GpDirEnumList("\\", 0, list_count, p_list, &read_count);

	for (i=0; i<read_count; i++)
	{
		err_code = GpFileAttr(p_list[i].name, &mAttr);
		if (err_code != SM_OK)
		{
			// none
		}
		if (gp_str_func.compare((const char*)p_list[i].name,".")==0)
		{	// .
			pi_list[i].type = 0; //root
		}
		else if (gp_str_func.compare((const char*)p_list[i].name,"..")==0)
		{	// ..
			pi_list[i].type = 1; //previous folder
		} else if (err_code == SM_OK && ((mAttr.attr & 0x10) == 0))	/* file */
		{
			pi_list[i].type = 3; //file
			GpFileGetSize(p_list[i].name, &ts);
			pi_list[i].size = (unsigned int)ts;
		}
		else	/* directory <-- (mAttr.attr & 0x10 == 1) */
		{
			pi_list[i].type = 2; //directory
		}
	}

	__printf("done.\n");
	return (int)read_count;
}


//   ...  0-, 1-, 2- -1-
int SelectFileDialog(char *start_path, int mode, char *output_path)
{
	int i,t,t1;
	int keydata;
	int gf_pos, sf_pos;
	char *current_path[256];

	//current_path = (char*)gp_mem_func.zimalloc(MAX_PATH_NAME_LEN);
	
	//   - 
	gf_pos = 0;
	//   
	sf_pos = 0;
	
	gp_str_func.strcpy((char*)&current_path, (const char*)start_path);

	if ( GetFilesList(start_path) <= 0 )
	{
		//    
		return -1;
	}

	//      ..     
	//GpKeyGetEx(&keydata);
	keydata = 0;
	while(1)
	{
		//keyboard
		if ( keydata & GPC_VK_UP ) //press UP
		{
			sf_pos--;
			if (sf_pos<0)
			{
				sf_pos = 0;
				gf_pos--;
				if (gf_pos<0)
				{
					gf_pos = 0;
				}
			}

		}
		if ( keydata & GPC_VK_DOWN ) //press DOWN
		{
			sf_pos++;
			if (sf_pos>=n_fstr*2)
			{
				sf_pos = n_fstr*2-1;
				gf_pos++;
			}
			if (gf_pos+sf_pos>= list_count)
			{
				sf_pos--;
			}

		}

		if ( keydata & GPC_VK_LEFT ) //press LEFT
		{
			//  1   
			if (gf_pos==0 && sf_pos<n_fstr)
			{
				sf_pos = 0;
			} else {
			//    
				sf_pos-=n_fstr;
				if (sf_pos<0)
				{
					gf_pos+=(sf_pos-1);
					if (gf_pos)
					{
						sf_pos+=n_fstr;
					} else
					{
						sf_pos=0;
					}
				}
				if (gf_pos<0)
				{
					gf_pos=0;
				}
			}
		}
		if ( keydata & GPC_VK_RIGHT ) //press RIGHT
		{
			sf_pos+=n_fstr;
			if ( sf_pos >= n_fstr*2 )
			{
				gf_pos+=n_fstr;
				sf_pos-=n_fstr;
			}
			if (gf_pos+sf_pos>= list_count)
			{
					sf_pos-=(gf_pos+sf_pos-(int)list_count+1);
			}
			if (sf_pos<0)
				sf_pos=0;
		}

		if ( keydata & GPC_VK_FA ) //press A
		{

			//__printf("Paths: rel %s, fin %s\n",_relative_path,_final_path);
			
			//      
			nflip++; nflip %= 2;

			t = pi_list[gf_pos+sf_pos].type;
			switch (t)
			{
				case 0:
					gp_str_func.strcpy((char*)current_path,"gp:\\");
					break;
				case 1:
					//GpRelativePathGet((char*)current_path);
					GpRelativePathGet((char*)&g_string);
					for (i=gp_str_func.gpstrlen((char*)&g_string)-2; i>2; i-- )
					{
						__putchar(g_string[i]);
						if ( g_string[i] == '\\')
						{
							g_string[++i] = 0;
							gp_str_func.strcpy((char*)current_path,(char*)&g_string);
							break;
						}
					}
					//GpRelativePathSet("\\..\\");
					//GpRelativePathSet((char*)current_path);
					__printf("cd .. ");
					break;
				case 2:	//folder
					GpRelativePathGet((char*)current_path);
					gp_str_func.strcat((char*)current_path, (const char*)p_list[gf_pos+sf_pos].name);
					break;
				default: //file
					GpRelativePathGet((char*)current_path);
					gp_str_func.strcpy((char*)output_path, (const char*)current_path);
					gp_str_func.strcat((char*)output_path, (const char*)p_list[gf_pos+sf_pos].name);
					gp_mem_func.free(pi_list);
					gp_mem_func.free(p_list);
					__printf("open file %s\n",output_path);
					return 0;
			}

			sf_pos = 1; //  .. 
			gf_pos = 0;
			__printf("cd %s\n",current_path);
			GetFilesList((char*)current_path);

		}
		if ( keydata & GPC_VK_FB) //press B
		{
			return 1;
		}

		//GpRectFill(NULL, &gpDraw[nflip], 0, 0, gpDraw[nflip].buf_w, gpDraw[nflip].buf_h, 0xff);

		DrawWindow(0, 0, 320, 240, nflip, 
		90,94,152,86,81);
		GpRectFill(NULL, &gpDraw[nflip], 2, 2, 316, 13, 27);
		GpRectFill(NULL, &gpDraw[nflip], 2, 17, 316, 14, 0xff);
		GpRectFill(NULL, &gpDraw[nflip], 2, 33, 316, 205, 0xff);

		//debug info
		//gp_str_func.sprintf(g_string, "%d,%d", gf_pos,sf_pos);
		//GpTextOut(NULL, &gpDraw[nflip], 280, 1, g_string, 0);

		GpTextOut(NULL, &gpDraw[nflip], 4, -1, "Select file...", 0);
		GpTextOut(NULL, &gpDraw[nflip], 2, 14, (char*)current_path, 0);

		//  
		for (i=0; i<n_fstr*2; i++)
		{
			if (gf_pos+i >= list_count)
			{
				break;
			}
			//cursor
			if (i == sf_pos)
				GpRectFill(NULL, &gpDraw[nflip], -1+10+(i/n_fstr)*151, 33+(i-(i>=n_fstr?n_fstr:0))*12, 150, 12, 123);
			t = pi_list[gf_pos+i].type;
			switch (t)
			{
				case 0:
					GpTextOut(NULL, &gpDraw[nflip], 10+(i/n_fstr)*151, 29+(i-(i>=n_fstr?n_fstr:0))*12, "< . >  Root", 160);
					break;
				case 1:
					GpTextOut(NULL, &gpDraw[nflip], 10+(i/n_fstr)*151, 29+(i-(i>=n_fstr?n_fstr:0))*12, "< .. > Previous", 240);
					break;
				case 2:	//folder
					gp_str_func.sprintf(g_string, "<%s>", p_list[gf_pos+i].name);
					GpTextOut(NULL, &gpDraw[nflip], 10+(i/n_fstr)*151, 29+(i-(i>=n_fstr?n_fstr:0))*12, g_string, 70);
					break;
				default: //file
					GpTextOut(NULL, &gpDraw[nflip], 10+(i/n_fstr)*151, 29+(i-(i>=n_fstr?n_fstr:0))*12, p_list[gf_pos+i].name, 0);
					t = pi_list[gf_pos+i].size;
					if (t<=999)
					{
						t1 = 'b';
					}
					else if (t <= 999999)
					{
						t /= 1000;
						t1 = 'K';
					}
					else
					{
						t /= 1000000;
						t1 = 'M';
					}
					gp_str_func.sprintf(g_string, "%4d%c", t, (char)t1);
					GpTextOut(NULL, &gpDraw[nflip], 10+(i/n_fstr)*151 + 13*8, 29+(i-(i>=n_fstr?n_fstr:0))*12, g_string, 16);
			}
		}

		//GpTextOut(NULL, &gpDraw[nflip], 270, 225, (char*)"by Don", 0xf);

		FlipAndShow();

 		//  
		Delay(100);
		GpKeyGetEx(&keydata);
		while (keydata == 0 )
		{
			GpKeyGetEx(&keydata);
			Delay(50);
		}

	}


	gp_mem_func.free(p_list);	
}

void FlipAndShow(void)
{
	//flip and show hidden surface		
		GpSurfaceFlip(&gpDraw[nflip++]);
		nflip %= 2;
}

void Delay(int ms) {

	unsigned int ticks;

	ticks=GpTickCountGet();
	while(GpTickCountGet()-ticks<ms);
}

void Cls(int color ,int nflip)
{
	// 
	GpRectFill(NULL, &gpDraw[nflip], 0,0,GPC_LCD_WIDTH,GPC_LCD_HEIGHT, color);

	//
	GpTextOut(NULL, &gpDraw[nflip], 2, 225, (char*)"U-Book v0.2b (c)2002 FaMe Soft", 0xf);
	// 
	gp_str_func.sprintf(g_string, "Memory Available:%d", gp_mem_func.availablemem());
	GpTextOut(NULL, &gpDraw[nflip], 2, 213, g_string, 0);

}

//       
void DrawMessage(char *s, int nflip)
{
	int tw,th;
	GPRECT rect;	
	rect.left = 2;
	rect.top = 2;
	rect.right = GPC_LCD_WIDTH;
	rect.bottom = GPC_LCD_HEIGHT;

 	//  
	tw=GpTextWidthGet(s);
	th=GpTextHeightGet(s);
	DrawWindow( (GPC_LCD_WIDTH - (tw+20) )/2, (GPC_LCD_HEIGHT - (th+20) )/2, tw+20, th+20, nflip,
	90,94,152,86,81);

	GpTextDraw(&gpDraw[nflip], &rect, GPC_GT_HCENTER | GPC_GT_VCENTER, 
		    	   (char*)s, 0, gp_str_func.gpstrlen(s), 0x0);
	rect.left = 0;
	rect.top = 0;
	GpTextDraw(&gpDraw[nflip], &rect, GPC_GT_HCENTER | GPC_GT_VCENTER, 
		    	   (char*)s, 0, gp_str_func.gpstrlen(s), 254);
}
//       
void DrawError(char *s, int nflip)
{
	int tw,th;
	GPRECT rect;	
	rect.left = 2;
	rect.top = 2;
	rect.right = GPC_LCD_WIDTH;
	rect.bottom = GPC_LCD_HEIGHT;

 	//  c !
	tw=GpTextWidthGet(s);
	th=GpTextHeightGet(s);
	DrawWindow( (GPC_LCD_WIDTH - (tw+20) )/2, (GPC_LCD_HEIGHT - (th+20) )/2, tw+20, th+20, nflip,
	224,240,241,192,160);

	GpTextDraw(&gpDraw[nflip], &rect, GPC_GT_HCENTER | GPC_GT_VCENTER, 
		    	   (char*)s, 0, gp_str_func.gpstrlen(s), 0x0);
	rect.left = 0;
	rect.top = 0;
	GpTextDraw(&gpDraw[nflip], &rect, GPC_GT_HCENTER | GPC_GT_VCENTER, 
		    	   (char*)s, 0, gp_str_func.gpstrlen(s), 254);
}

// green 90,94,152,86,81
// red 224,240,241,192,160

void DrawWindow(int x, int y, int lx, int ly, int nflip, int c1, int c2, int c3, int c4, int c5)
{
	//  
	GpRectFill(NULL, &gpDraw[nflip], x+5,y+5,lx,ly, 0);
	GpRectFill(NULL, &gpDraw[nflip], x-1,y-1,lx+2,ly+2, 0);
	//CurrentColor=wfon;
	GpRectFill(NULL, &gpDraw[nflip], x,y,lx,ly, c1);
	//CurrentColor=wlight;
	GpRectFill(NULL, &gpDraw[nflip], x,y,lx,1, c2);
	GpRectFill(NULL, &gpDraw[nflip], x,y,1,ly, c2);
	//CurrentColor++;
	GpRectFill(NULL, &gpDraw[nflip], x,y,1,1, c3);
	//CurrentColor=wshadow;
	GpRectFill(NULL, &gpDraw[nflip], x,y+ly-1,lx,1, c4);
	GpRectFill(NULL, &gpDraw[nflip], x+lx-1,y+1,1,ly-1, c4);
	//CurrentColor++;
	GpRectFill(NULL, &gpDraw[nflip], x+lx-1,y+ly-1,1,1, c5);
}