#include "gpdef.h"
#include "gpstdlib.h"
#include "gpgraphic.h"
#include "gpfont.h"
#include "gpstdio.h"

#include "bfont.h"
#include "file_dialog.h"
#include "print_text.h"
#include "gpmain.h"

extern GPDRAWSURFACE gpDraw[2];
extern int nflip;
char g_string[100];

unsigned char *LoadHtmlLineN(int n,unsigned char *text_src, struct BFont *font);
void PrintHtmlN(GPDRAWTAG * gptag, GPDRAWSURFACE * ptgpds,struct BFont *font, int x, int y, char * sour, int nStart, int nString);
void PrintTextN(GPDRAWTAG * gptag, GPDRAWSURFACE * ptgpds,struct BFont *font, int x, int y, char * sour, int nStart, int nString);
extern void _processEngChar(GPDRAWTAG * gptag, 
			GPDRAWSURFACE * ptgpds,	int x,	int y,	char data1,
			unsigned char color);
extern void _processKorChar(GPDRAWTAG * gptag,
			GPDRAWSURFACE * ptgpds,	int x,	int y,	char data1,
			char data2,	unsigned char color);

#define max_text_str 15000
struct ELine {
	unsigned char *S; //   
	//unsigned char *NS; //  1   
	unsigned char len; //  
	//int width; //   
	//int p; //1 -  "-" 0 - .
} EB[max_text_str];

//struct Eline EB[48]; // ...  48 .. 48*5

//  0- 1- 2-
int view_mode = 0;
//  -   ...
int html_mode = 0;

unsigned long text_len = 0;

unsigned int text_n_lines = 0; //-    
int max_display_lines = 48; //     
unsigned char *text_source;

char text_file_name[256];

struct BFont fonts[4];
struct BFont *curr_font,*hex_font;
#define max_font_n 4
int font_n = 2;


F_HANDLE h_rfile;
unsigned long n_dummy;
ERR_CODE err_code;


void ViewText(void)
{
	int pos_y,pos,i;
	int keydata;
	unsigned char *tmp;
	long hexpos;

	pos_y=0;
	//   
	pos=0;
	hexpos=0;

	//      ..     
	GpKeyGetEx(&keydata);
	while(1)
	{
		//keyboard
		if ( keydata & GPC_VK_UP ) //press UP
			{
			pos--;
			if (pos<0)
			{
				pos = 0;
			}
			//hex
			hexpos-=16;
			if (hexpos<0)
			{
				hexpos = 0;
			}

		}
		if ( keydata & GPC_VK_DOWN ) //press DOWN
			{
			//      -   
			if (text_n_lines <= max_display_lines)
			{
				pos=0;
			}
			else
			{
				pos++;
				if (pos > text_n_lines- max_display_lines+1)
				{
					pos = text_n_lines - max_display_lines+1;
				}
			}
			if (pos < 0)
			{
				pos=0;
			}
			//hex
			if ( text_len <= 30*16)
			{
				hexpos=0;
			}
			else
			{
				hexpos+=16;
				if (hexpos>text_len - 30*16+1)
				{
					hexpos -= 16;
				}
			}

		}
		if ( keydata & GPC_VK_FL ) //press L-Shoulder
			{
			pos-=max_display_lines;
			if (pos<0)
			{
				pos = 0;
			}
			//hex
			hexpos-=16*30;
			if (hexpos<0)
			{
				hexpos = 0;
			}
		}
		if ( keydata & GPC_VK_FR ) //press R-Shoulder
		{
			//      -   
			if (text_n_lines <= max_display_lines)
			{
				pos=0;
			}
			else
			{
				pos+=max_display_lines;
				if (pos > text_n_lines- max_display_lines)
				{
					pos = text_n_lines - max_display_lines;
				}
			}
			if (pos < 0)
			{
				pos=0;
			}
			//hex
			if ( text_len <= 30*16)
			{
				hexpos=0;
			}
			else
			{
				hexpos+=16*30;
				if (hexpos>text_len - 30*16)
				{
					hexpos = text_len - 30*16;
				}
			}

		}

		if ( keydata == (GPC_VK_LEFT | GPC_VK_SELECT) ) //press SELECT+LEFT
		{
			//text view
			view_mode = 0;
		}
		if ( keydata == (GPC_VK_RIGHT | GPC_VK_SELECT) ) //press SELECT+RIGHT
		{
			//hex view
			view_mode = 1;
		}
		// 
		if ( keydata == (GPC_VK_UP | GPC_VK_SELECT) ) //press SELECT+LEFT
		{
			if (font_n < max_font_n-1)
			{
				font_n++;
				curr_font = &fonts[font_n];
				tmp = EB[pos].S;
				FormatText();
				pos = 0;
				for (i=0; i<text_n_lines; i++)
				{
					if (tmp <= EB[i].S)
					{
						pos = i;
						break;
					}
				}
			}
		}
		if ( keydata == (GPC_VK_DOWN | GPC_VK_SELECT) ) //press SELECT+RIGHT
		{
			if (font_n > 0)
			{
				font_n--;
				curr_font = &fonts[font_n];	
				tmp = EB[pos].S;
				FormatText();				
				pos = 0;
				for (i=0; i<text_n_lines; i++)
				{
					if (tmp <= EB[i].S)
					{
						pos = i;
						break;
					}
				}
			}
		}

/*		if ( keydata & GPC_VK_FA ) //press A
		{
		}*/
		
		if ( keydata == (GPC_VK_FL | GPC_VK_SELECT)) //press Select +Left Shoulder
		{
			//  
			return;
		}
		if ( keydata == (GPC_VK_START | GPC_VK_SELECT)) //press Start+Select
		{
			//
			FreeText();
			GpAppExit();
		}
		if ( keydata == (GPC_VK_START)) //press Start
		{
			//
			
			DrawMessage(
			"HOT KEYS HELP\n\n"
			"[Start] = Help\n"
			"[Up / Down] = Scroll Text\n"
			"[Left Shoulder] = Previous page\n"
			"[Right Shoulder] = Next page\n"
			"[Select]+[Up / Down] = Change Font\n"
			"(The Biggest Font Is Korean!!!)\n"
			"[Select]+[Right] = Set HEX Mode\n"
			"[Select]+[Left] = Set Text Mode\n\n"
			"[Select]+[Left Shoulder] = Load File\n\n"
			"[Start]+[Select] = Reboot GP32\n"
			, 0);
			
			Delay(500);
			GpKeyGetEx(&keydata);
			while (keydata == 0 )
			{
				GpKeyGetEx(&keydata);
				Delay(5);
			}

		}

		switch (view_mode)
		{
			case 0:	//Plain Text
				//clear page
				GpRectFill(NULL, &gpDraw[nflip], 0, 0, gpDraw[nflip].buf_w, gpDraw[nflip].buf_h, 0xff);
				//draw text
				PrintLines(pos, curr_font);
				break;

			case 1:	//HEX
				PrintHEXLines(hexpos, hex_font);
				break;

			case 2:	//HEW Dump memory
				//clear page
				GpRectFill(NULL, &gpDraw[nflip], 0, 0, gpDraw[nflip].buf_w, gpDraw[nflip].buf_h, 0x2);
				break;
		}

		//put logo
		GpTextOut(NULL, &gpDraw[nflip], 270, 225, (char*)"by Don", 0xf);

		FlipAndShow();

 		//delay for a smooth moving
		Delay(45);
		GpKeyGetEx(&keydata);
		while (keydata == 0 )
		{
			GpKeyGetEx(&keydata);
			Delay(5);
		}

	}
}

void LoadFonts(void)
{
	unsigned char font_colors[]={0,1,2,3};

	Cls(255,0);
	DrawMessage("Loading...\nDMF font 4x6...", 0);
	//if ( LoadFont("gp:\\gpmm\\ubook\\bf_4x6.dmf", &fonts[0], (unsigned char*)&font_colors) != SM_OK)
	if ( LoadFont("gp:\\gpmm\\ubook\\bf_22x20.bmp", &fonts[0], (unsigned char*)&font_colors) != SM_OK)
	{
		DrawError("I/O ERROR: Can't load DMF font 4x6!\nReset your GP32 please",0);
		while (1)
		;
	}
	fonts[0].chargap = 2;
	Cls(255,0);
	DrawMessage("Loading...\nDMF font 6x8...", 0);
	if ( LoadFont("gp:\\gpmm\\ubook\\bf_6x8.dmf", &fonts[1], (unsigned char*)&font_colors) != SM_OK)
	{
		DrawError("I/O ERROR: Can't load DMF font 6x8!\nReset your GP32 please",0);
		while (1)
		;
	}
	Cls(255,0);
	DrawMessage("Loading...\nDMF font 11x10...", 0);
	if ( LoadFont("gp:\\gpmm\\ubook\\bf_11x10.dmf", &fonts[2], (unsigned char*)&font_colors) != SM_OK)
	{
		DrawError("I/O ERROR: Can't load DMF font 11x10!\nReset your GP32 please",0);
		while (1)
		;
	}
	DrawMessage("Loading...\nSystem font 16x12...", 0);
	if ( LoadFont("system", &fonts[3], (unsigned char*)&font_colors) != SM_OK)
	{
		DrawError("I/O ERROR: Can't load DMF font 11x10!\nReset your GP32 please",0);
		while (1)
		;
	}
	//  
	curr_font = &fonts[font_n];
	//    HEX Niew mode
	hex_font = &fonts[1];
}

void LoadText(void)
{
	int i;

	//    
	do
	{
		i = SelectFileDialog("gp:\\", 1, text_file_name);
		if (i != 0)
		{
			Cls(255,nflip);
			DrawError("I/O ERROR: Can't open file\nPlease select another one",nflip);
			FlipAndShow();
			Delay(5 * 1000);
			
		}
	} while (i != 0);

	//
	//GpAppExecute(text_file_name,"gp:\\");

	GpFileGetSize(text_file_name, &text_len);
	//  !!
	if (err_code != SM_OK /*|| text_len>64121*/ )
	{
		GpAppExit();
		return;
	}

	Cls(255,nflip);
	gp_str_func.sprintf(g_string, "Loading file...\n%s\n%d Bytes", text_file_name, text_len);
	DrawMessage(g_string, nflip);
	FlipAndShow();

	//GpUserInfoGet((char *)&gs1,(char *)&gs2);
	//gp_str_func.sprintf(g_string, "Fsize: %d %s %s", text_len,&gs1,&gs2);
	//GpTextOut(NULL, &gpDraw[0], 0, 204, g_string, 0);
	//text_len = 64000;

	err_code = GpFileOpen(text_file_name, OPEN_R, &h_rfile);
	if (err_code != SM_OK)
	{
		return;
	}
	text_source = (unsigned char*)gp_mem_func.zimalloc((unsigned int)text_len+1);
	//text_source = (unsigned char*)malloc(text_len+4);
	if (text_source == NULL)
	{
		return;
	}
	err_code = GpFileRead(h_rfile, text_source, text_len, (ulong*)&n_dummy);
	if (err_code != SM_OK)
	{
		return;
	}
	if (n_dummy != text_len)
	{
		return;
	}

	//-     
	//GpFileClose(h_rfile);
}

//   - 
void FreeText(void)
{
	Cls(255,nflip);
	gp_str_func.sprintf(g_string, "Closing file...\n%s", text_file_name);
	DrawMessage(g_string, nflip);
	FlipAndShow();

	gp_mem_func.free(text_source);
	/*if (text_source == NULL)
	{
		return;
	}*/
	GpFileClose(h_rfile);
}

void FormatText(void)
{
	// -     
	max_display_lines = 240/(curr_font->height);

	//GpTextOut(NULL, &gpDraw[0], 0, 36, ( char*)"Formatting the text...", 0x0);
	Cls(255,nflip);
	DrawMessage("Formatting the text...", nflip);
	FlipAndShow();
	GetLines(text_source, text_len, curr_font);
	//text_n_lines = 100;

	//   
	if (text_len>16 && text_n_lines <=1)
	{
			//HEX mode
			view_mode = 1;
	}
}

void PrintLines(int pos, struct BFont *font)
{
	int i,j;
	j= pos-1;
	//      
	for (i=0; i<max_display_lines; i++)
	{
		//  ,   -
		if (++j > text_n_lines) {
			//  
			GpRectFill(NULL, &gpDraw[nflip], 0, i*font->height+1, gpDraw[nflip].buf_w, 2, 0x1);
			break;
		}

		if ( EB[j].S != NULL) {
			if (html_mode)
			{
				PrintHtmlN(NULL, &gpDraw[nflip],font,0,i*font->height,(char *)EB[j].S,0,EB[j].len);			
			}
			else
			{
				PrintTextN(NULL, &gpDraw[nflip],font,0,i*font->height,(char *)EB[j].S,0,EB[j].len);			
				//BTextNOut(NULL, &gpDraw[nflip],font,0,i*font->height,(char *)EB[j].S,0,EB[j].len);
			}
			
		}
	}

}

//  HTML     .
void PrintHtmlN(GPDRAWTAG * gptag, GPDRAWSURFACE * ptgpds,struct BFont *font, int x, int y, 
	char * sour, int nStart, int nString)
{
	char *s;
	int	f=0; //     
	int xp=x;
	
	s = (sour + nStart);
	
	if (font->type == 2)
	{	//korean
		do {
			//  - 
			while (*s == '<') {
				do {
					s++;
					if (s >= sour+nStart+nString)
						break;
				} while (*s != '>');
				s++;
			}
			//  ,   
			if (*s == 0 || *s == '\n' || *s == '\r') {
				break;
			}
			// , 
			if (*s == ' ' || *s == '\t') {
				while (*s == ' ' || *s == '\t') {
					s++;
				}
				if (f != 0)
				{	//   ,    
					xp += font->width + font->chargap;
				}
			}
		
			if((*s) & 0x80) //korean
			{
				f=1;
				_processKorChar(
				NULL, &gpDraw[nflip],
				xp, y,
				(char)*s,(char)*(s+1),
				1);
				//BTextNOut(NULL, &gpDraw[nflip],font, xp, y, s, 0, 2);
				xp += font->kor_w + font->chargap;
				s += 2;				
			}
			else
			{	//ASCII
				f=1;
				_processEngChar(
				NULL, &gpDraw[nflip],
				xp, y,
				(char)*s,
				1);
				//BTextNOut(NULL, &gpDraw[nflip],font, xp, y, s, 0, 1);							
				xp += font->width + font->chargap;
				s++;
			}

		} while  (s < sour+nStart+nString);
	
	}
	else
	{	//ascii
		do {
			//  - 
			while (*s == '<') {
				do {
					s++;
					if (s >= sour+nStart+nString)
						break;
				} while (*s != '>');
				s++;
			}
			//  ,   
			if (*s == 0 || *s == '\n' || *s == '\r') {
				break;
			}
			// , 
			if (*s == ' ' || *s == '\t') {
				while (*s == ' ' || *s == '\t') {
					s++;
				}
				if (f != 0)
				{	//   ,    
					xp += font->c[' '].width + font->chargap;
				}
			}
			f=1;
			BTextNOut(NULL, &gpDraw[nflip],font, xp, y, s, 0, 1);							
			xp += font->c[*s].width + font->chargap;
			s++;

		} while  (s < sour+nStart+nString);
	
	}

}

//   
void PrintTextN(GPDRAWTAG * gptag, GPDRAWSURFACE * ptgpds,struct BFont *font, int x, int y, 
	char * sour, int nStart, int nString)
{
	char *s;
	int	f=0; //     
	int xp=x;
	
	s = (sour + nStart);
	
	if (font->type == 2)
	{	//korean
		do {
			//  ,   
			if (*s == 0 || *s == '\n' || *s == '\r') {
				break;
			}
			// , 
			if (*s == ' ' || *s == '\t') {
				while (*s == ' ' || *s == '\t') {
					s++;
				}
				if (f != 0)
				{	//   ,    
					xp += font->width + font->chargap;
				}
			}
		
			if((*s) & 0x80) //korean
			{
				f=1;
				_processKorChar(
				NULL, &gpDraw[nflip],
				xp, y,
				(char)*s,(char)*(s+1),
				1);
				//BTextNOut(NULL, &gpDraw[nflip],font, xp, y, s, 0, 2);
				xp += font->kor_w + font->chargap;
				s += 2;				
			}
			else
			{	//ASCII
				f=1;
				_processEngChar(
				NULL, &gpDraw[nflip],
				xp, y,
				(char)*s,
				1);
				//BTextNOut(NULL, &gpDraw[nflip],font, xp, y, s, 0, 1);							
				xp += font->width + font->chargap;
				s++;
			}

		} while  (s < sour+nStart+nString);
	
	}
	else
	{	//ascii
		do {
			//  ,   
			if (*s == 0 || *s == '\n' || *s == '\r') {
				break;
			}
			// , 
			if (*s == ' ' || *s == '\t') {
				while (*s == ' ' || *s == '\t') {
					s++;
				}
				if (f != 0)
				{	//   ,    
					xp += font->c[' '].width + font->chargap;
				}
			}
			f=1;
			BTextNOut(NULL, &gpDraw[nflip],font, xp, y, s, 0, 1);							
			xp += font->c[*s].width + font->chargap;
			s++;

		} while  (s < sour+nStart+nString);
	
	}

}

void PrintHEXLines(long pos, struct BFont *font)
{
	int i,x;
	long j;
	j= pos;

	// 
	//    
	GpRectFill(NULL, &gpDraw[nflip], 0, 0, gpDraw[nflip].buf_w, gpDraw[nflip].buf_h, 0xff);
	for (x=0; x<16; x++)
	{
			GpRectFill(NULL, &gpDraw[nflip], 5*6+x*12, 0, 12, gpDraw[nflip].buf_h, 222+(x&1));
	}

	for (i=0; i<30; i++)
	{
		// 
		gp_str_func.sprintf(g_string, "%05X", j);
		BTextOut(NULL, &gpDraw[nflip],font,0,i*font->height,(char *)g_string);
		// HEX   

		for (x=0; x<16; x++)
		{
			PrtHexN(5*6+x*12,i*font->height, (unsigned int)*(text_source+j), font);			
			Put1Chara(NULL,&gpDraw[nflip],font,224+x*font->width, i*font->height,(unsigned char)*(text_source+j));

			//  ...    
			if (++j >= text_len)return;;
		}

	}

}

// 1 HEX 
void PrtHexN(int x, int y, unsigned int c, struct BFont *font)
{
	const unsigned int ct[16]={'0','1','2','3','4','5','6','7','8','9','A','B','C','D','E','F'};
	Put1TrChara(NULL,&gpDraw[nflip],font,x,y,(unsigned char)ct[c>>4]);
	Put1TrChara(NULL,&gpDraw[nflip],font,x+font->width, y,(unsigned char)ct[c&0xf]);
}


int GetLines(unsigned char *text_src, unsigned long text_len, struct BFont *font)
{
	unsigned int i;
	unsigned char *s;

	s = text_src;

	for (i=0; i<max_text_str; i++)
	{
		
		if (html_mode)
		{
			s = LoadHtmlLineN(i,s, font);
		}
		else
		{
			s = LoadLineN(i,s, font);
		}

		if ( s-text_src >= text_len )
		{ // . .    
			text_n_lines = i;
			break;
		}
	}
	return 0;
}
//   ...  .. 
unsigned char *LoadLineN(int n,unsigned char *text_src, struct BFont *font)
{
	int len,line_width;
	unsigned char *s, *t;

	//if (n>=48 || s == NULL) return -1; //  .. 8)      48

	s = (EB[n].S = text_src);
	len=0;
	line_width = 0;
	
	//   
	if (font->type == 2) {
		while (1) {
			//  
			if (*s == 0) {
				EB[n].len = s-text_src+1;
				break;
			}
			//   
			if (*s == '\n' || *s == '\r')
			{
				if (*(s+1) == '\n' || *(s+1) == '\r')
				{
					EB[n].len = (unsigned char)(s-text_src);
					return s+2;
				}
				EB[n].len = (unsigned char)(s-text_src);
				return s+1;
				break;
			}
			if((*s) & 0x80) //korean
			{
				if (line_width + font->kor_w > 320)
				{
					break;
				}
				line_width += (font->kor_w + font->chargap);
				s += 2;				
			}
			else
			{	//ASCII
				if (line_width + font->width > 320)
				{
					break;
				}
				line_width += (font->width + font->chargap);
				s++;
			}
		}
		
		//  -   
		if (*s != ' ' && *s != '\t' && *s != '\r' && *s != '\n')
		{
			t = s;
			//   ...   
			while (t > text_src+1)
			{
				if (*t == ' ' || *t == '\t')
				{
					EB[n].len = (unsigned char)(t-text_src);
					return t+1;
				}
				t--;
			}
		}

		//-   
		EB[n].len = (unsigned char)(s-text_src);
		return s;
	}

//  - 
	while (1) {
		//  
		if (*s == 0) {
			EB[n].len = s-text_src+1;
			return s;
			break;
		}
		//   
		if (*s == '\n' || *s == '\r') {
			if (*(s+1) == '\n' || *(s+1) == '\r')
			{
				EB[n].len = (unsigned char)(s-text_src);
				return s+2;
			}
			EB[n].len = (unsigned char)(s-text_src);
			return s+1;
			break;
		}
		if (line_width + font->c[*s].width > 320)
		{
			break;
		}
		line_width += (font->c[*s++].width + font->chargap);
	}
	
	//  -   
	if (*s != ' ' && *s != '\t' && *s != '\r' && *s != '\n')
	{
		t = s;
		//   ...   
		while (t > text_src+1)
		{
			if (*t == ' ' || *t == '\t')
			{
				EB[n].len = (unsigned char)(t-text_src);
				return t+1;
			}
			t--;
		}
	}

	//-   
	EB[n].len = (unsigned char)(s-text_src);

	return s;
}

// HTML   ...  .. 
unsigned char *LoadHtmlLineN(int n,unsigned char *text_src, struct BFont *font)
{
	int len,line_width,f=0;
	unsigned char* s;

	//if (n>=48 || s == NULL) return -1; //  .. 8)      48

	s = (EB[n].S = text_src);
	len=0;
	line_width = 0;
	
	//   
	if (font->type == 2) {
		do {
			//  
			if (*s == 0) {
				EB[n].len = s-text_src+1;
				break;
			}

			// HTML!
			//---------------------------------------
			// 			
			while (*s == ' ' || *s == '\t' || *s == '\n' || *s == '\r') {
				if (f == 0)
				{	//    ,   - 
					EB[n].S++;
				}
				s++;
			}
			// 
			while (*s == '<') {
				do {
					s++;
				} while (*s != '>' && *s != 0);
				s++;
				//    
				while (*s == ' ' || *s == '\t' || *s == '\n' || *s == '\r') {
					s++;
				}
				continue;
			}
			//------------------------------------------------

			if((*s) & 0x80) //korean
			{
				f=1;
				line_width += (font->kor_w + font->chargap);
				s += 2;				
			}
			else
			{	//ASCII
				f=1;
				line_width += (font->width + font->chargap);
				s++;
			}
		} while (line_width < (320 - font->width) );
	
	
		EB[n].len = (unsigned char)(s-text_src);
		return s;
	}
//  - 
	do {
		//  
		if (*s == 0) {
			//EB[n].NS = NULL;
			//EB[n].p = (*(s-1) != ' ');
			//EB[n].width = line_width;
			EB[n].len = s-text_src+1;
			break;
		}
		//   
		if (*s == '\n' || *s == '\r') {
			/*do { //     
				s++;
			}
			while ( *s < 16 || *s == ' ');*/
			s++;
			if (*s == '\n' || *s == '\r') s++;
			break;
		}
		line_width += (font->c[*s++].width + font->chargap);
	}
	while (line_width < (320 - font->width) );

	//EB[n].NS = s;
	// 
	//EB[n].p = (*(s-1) != ' ');
	//EB[n].width = line_width;
	//-   
	EB[n].len = (unsigned char)(s-text_src);

	return s;
}
